
QGIS Application - Bug report #4109

Save-as to "original CRS" incorrectly reprojects if OTF reprojection is disabled

2011-07-22 04:21 AM - Alister Hood

Status: Closed

Priority: High

Assignee:

Category: GUI

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 14091

Description

With on-the-fly reprojection disabled, right-click on a shape file with a CRS (defined in a .prj file) that does not match the project CRS, and

choose "Save as".  Save to the "original CRS".  Open the new file - you will see that it has been reprojected from the layer's original CRS

into the project CRS.  

This does not make sense.  It should either:

- not be reprojected and the new .prj file should have the same CRS as the old .prj file (this is what happens when on-the-fly reprojection

is enabled), or

- not be reprojected and the new .prj file should have the project CRS.

I'm not really sure which would be better - maybe there should be a choice: "This project has on-the-fly reprojection disabled and the

original layer CRS does not match the project CRS.  Would you like to treat the original layer as being in the project CRS?"

Perhaps there should also be a choice if the user has done "Set layer CRS": "The user-defined layer CRS does not match the CRS

defined in the .prj file.  Which CRS would you like to treat the original layer as being in?"

N.B. I am running trunk - I'm not sure if this bug is also present in 1.7.

Associated revisions

Revision 3f50017a - 2012-02-03 09:17 AM - Jürgen Fischer

vector layer save as: replace 'original crs' with 'layer crs' and 'project crs' - OTFR doesn't matter anymore (fixes #4109)

Revision b3807b72 - 2012-02-11 05:22 PM - Jürgen Fischer

vector layer save as: replace 'original crs' with 'layer crs' and 'project crs' - OTFR doesn't matter anymore (fixes #4109)

History

#1 - 2011-12-16 02:12 PM - Giovanni Manghi

- Target version set to Version 1.7.4

#2 - 2011-12-24 06:36 AM - Giovanni Manghi

- Status changed from Open to Feedback

- Affected QGIS version set to master

- Crashes QGIS or corrupts data set to No

I have tested both master and 1.7.3 under Windows and Linux and I cannot replicate the issue. Please check again and report back.
#3 - 2012-01-08 06:14 PM - Alister Hood

Giovanni Manghi wrote:

I have tested both master and 1.7.3 under Windows and Linux and I cannot replicate the issue. Please check again and report back.

Yes, you're right, but I now find that it occurs with on-the-fly reprojection ENABLED.  This doesn't really make sense either, although it would be nice to

have a quick choice between saving  to the original layer CRS or the original project CRS.

It might actually make sense to have another dialogue, "You have selected to save to the original CRS, but the original layer CRS does not match the

project CRS.  Which CRS would you like to save to?".  This would prevent people getting confused by saving to the wrong CRS.

#4 - 2012-01-28 04:06 PM - Giovanni Manghi

Alister Hood wrote:

Giovanni Manghi wrote:

I have tested both master and 1.7.3 under Windows and Linux and I cannot replicate the issue. Please check again and report back.

Yes, you're right, but I now find that it occurs with on-the-fly reprojection ENABLED.  This doesn't really make sense either, although it would be nice

to have a quick choice between saving  to the original layer CRS or the original project CRS.

It might actually make sense to have another dialogue, "You have selected to save to the original CRS, but the original layer CRS does not match

the project CRS.  Which CRS would you like to save to?".  This would prevent people getting confused by saving to the wrong CRS.

Regardless of having OTFR enabled or disabled I can always "save as..." a vector in the CRS I choose in the dialog. If you are still having problems it

might be something related to a specific dataset? Try attach a sample.

#5 - 2012-02-02 08:04 PM - Alister Hood

Regardless of having OTFR enabled or disabled I can always "save as..." a vector in the CRS I choose in the dialog

Perhaps you misunderstand.  Don't choose a CRS.  Use the default "Original CRS" setting.

#6 - 2012-02-02 08:10 PM - Alister Hood

- File test_orig.zip added

Here is a sample in "New Zealand Transverse Mercator 2000".

Load the file.  Enable OTFR and change the project CRS to "New Zealand Map Grid".

Right-click on the file and choose "Save as".  Use the default "Original CRS" setting.

Load the new file - you will see it is in NZMG.

#7 - 2012-02-03 12:18 AM - Jürgen Fischer
- Status changed from Feedback to Closed

- % Done changed from 0 to 100

Fixed in changeset commit:"3f50017a97ee61deecdf022dcc7b6023c5229881".

#8 - 2012-02-06 02:42 PM - Alister Hood

Thanks, that dialog has suddenly become much nicer ;)

Files

test_orig.zip 1.56 KB 2012-02-02 Alister Hood
